#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2600eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 2600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight26004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight26004xi = {
                1:'-1021x-145y-2386z',
                2:'-102x-448y-2558z',
                3:'-1034x-1611y-1758z',
                4:'-1044x-1857y-1489z',
                5:'-1051x-94y-2376z',
                6:'-1052x-672y-2280z',
                7:'-1105x-627y-2267z',
                8:'-1107x-2347y-155z',
                9:'-1127x-1569y-1739z',
                10:'-1148x-1813y-1467z',
                11:'-1157x-578y-2255z',
                12:'-1206x-526y-2242z',
                13:'-1219x-1521y-1719z',
                14:'-1229x-2287y-129z',
                15:'-1250x-1762y-1446z',
                16:'-1253x-470y-2228z',
                17:'-1297x-411y-2215z',
                18:'-1308x-1468y-1700z',
                19:'-132x-467y-2554z',
                20:'-1338x-348y-2201z',
                21:'-1348x-2220y-103z',
                22:'-1349x-1705y-1424z',
                23:'-1395x-1410y-1680z',
                24:'-142x-857y-2450z',
                25:'-1446x-1643y-1402z',
                26:'-1462x-2147y-77z',
                27:'-1479x-1346y-1660z',
                28:'-1540x-1575y-1380z',
                29:'-1560x-1277y-1640z',
                30:'-1573x-2068y-51z',
                31:'-1630x-1501y-1358z',
                32:'-1638x-1203y-1620z',
                33:'-165x-483y-2549z',
                34:'-1680x-1984y-25z',
                35:'-1712x-1125y-1599z',
                36:'-1717x-1423y-1336z',
                37:'-173x-1740y-1923z',
                38:'-1781x-1893y0z',
                39:'-1783x-1042y-1579z',
                40:'-1799x-1339y-1314z',
                41:'-1849x-954y-1558z',
                42:'-186x-1996y-1654z',
                43:'-1878x-1250y-1291z',
                44:'-1910x-862y-1537z',
                45:'-191x-2570y-336z',
                46:'-192x-872y-2441z',
                47:'-1952x-1156y-1268z',
                48:'-1967x-767y-1516z',
                49:'-199x-498y-2543z',
                50:'-2019x-667y-1495z',
                51:'-2021x-1058y-1246z',
                52:'-2065x-565y-1474z',
                53:'-2085x-956y-1223z',
                54:'-2106x-459y-1452z',
                55:'-2142x-350y-1430z',
                56:'-2143x-850y-1200z',
                57:'-2171x-239y-1409z',
                58:'-2196x-741y-1177z',
                59:'-2243x-628y-1153z',
                60:'-2284x-512y-1130z',
                61:'-236x-510y-2538z',
                62:'-244x-885y-2432z',
                63:'-25x-382y-2571z',
                64:'-267x-1748y-1905z',
                65:'-274x-519y-2532z',
                66:'-293x-2000y-1634z',
                67:'-297x-894y-2423z',
                68:'-314x-526y-2526z',
                69:'-326x-2560y-310z',
                70:'-353x-899y-2413z',
                71:'-355x-529y-2520z',
                72:'-362x-1750y-1888z',
                73:'-397x-530y-2513z',
                74:'-401x-1998y-1614z',
                75:'-409x-902y-2403z',
                76:'-441x-528y-2507z',
                77:'-458x-1747y-1870z',
                78:'-460x-2543y-285z',
                79:'-467x-900y-2393z',
                80:'-485x-522y-2500z',
                81:'-48x-406y-2567z',
                82:'-509x-1990y-1593z',
                83:'-525x-895y-2383z',
                84:'-530x-514y-2492z',
                85:'-554x-1738y-1852z',
                86:'-56x-2573y-362z',
                87:'-574x-502y-2485z',
                88:'-585x-886y-2373z',
                89:'-593x-2518y-259z',
                90:'-5x-357y-2575z',
                91:'-617x-1975y-1573z',
                92:'-619x-486y-2477z',
                93:'-644x-873y-2362z',
                94:'-651x-1724y-1833z',
                95:'-664x-467y-2469z',
                96:'-704x-857y-2351z',
                97:'-709x-445y-2461z',
                98:'-724x-2485y-233z',
                99:'-725x-1955y-1552z',
                100:'-748x-1704y-1815z',
                101:'-74x-428y-2563z',
                102:'-753x-419y-2452z',
                103:'-764x-836y-2340z',
                104:'-795x-390y-2444z',
                105:'-81x-1728y-1940z',
                106:'-81x-1987y-1674z',
                107:'-823x-811y-2328z',
                108:'-832x-1929y-1531z',
                109:'-837x-357y-2435z',
                110:'-844x-1679y-1796z',
                111:'-854x-2446y-207z',
                112:'-878x-321y-2425z',
                113:'-882x-782y-2316z',
                114:'-916x-282y-2416z',
                115:'-939x-1896y-1510z',
                116:'-940x-1648y-1777z',
                117:'-940x-750y-2305z',
                118:'-953x-240y-2406z',
                119:'-982x-2400y-181z',
                120:'-988x-194y-2396z',
                121:'-98x-871y-2553z',
                122:'-996x-713y-2292z'}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2600eight4xi" usage = "target function for charge2600eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2600eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2600EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2600EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2600EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2600EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2600EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight26004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2600EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2600EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2600EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight26004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight26004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2600EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2600EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2600EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2600eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  